/*************************************************************************
* Author:   Marcus Boerger (http://marcus-boerger.de/)
* Name:     enumset/test1.cpp
*
* Function: Test enumset.hpp
*************************************************************************/

#include <typeinfo>
#include <stdio.h>
#include "enumset.hpp"
       
using namespace mbo;

typedef enum _Tenum {a=0, b, c} Tenum;

typedef enumset<int> Tset;

int main(int argc,char **argv)
{
	// create a set of doubles
	try {
		Tset	sd, sd0, sd1, sd2, sd3, sd4, sd5, sd6, sd7;
	
	    printf("sd0:%d\n", (size_t)sd0);
	
		sd  = Tset(a);
		sd += b;
		sd += c;
		sd -= b;
		sd5 = sd;
	
		sd  = sd + b;
		sd  = sd - c;
		sd3 = sd;
	    sd7 = sd3 + sd5;
	
	    printf("sd3:%d\n", (size_t)sd3);
	    printf("sd5:%d\n", (size_t)sd5);
	    printf("sd7:%d\n", (size_t)sd7);
	    
		printf("\n");
		sd2 = b;	
	    sd4 = c;
	    sd6 = sd2 + c;
	    sd.clear();
	    sd += a;
	    sd1 = sd0 + sd;
	    printf("sd :%d\n", (size_t)sd);
	    printf("sd1:%d\n", (size_t)sd1);
	    printf("sd2:%d\n", (size_t)sd2);
	    printf("sd4:%d\n", (size_t)sd4);
	    printf("sd6:%d\n", (size_t)sd6);

		printf("\n");
		sd2 = sd3 * sd6;
		sd4 = sd6;
		sd4*= sd5;
		sd  = sd4 * sd6;
	    printf("sd :%d\n", (size_t)sd);
	    printf("sd1:%d\n", (size_t)sd1);
	    printf("sd2:%d\n", (size_t)sd2);
	    printf("sd3:%d\n", (size_t)sd3);
	    printf("sd4:%d\n", (size_t)sd4);
	    printf("sd5:%d\n", (size_t)sd5);
	    printf("sd6:%d\n", (size_t)sd6);
	
		printf("\n");	
		printf("sd2 & sd4        == false: %s\n", sd2&sd            ? "true" : "false");
		printf("sd2 & sd3        == true : %s\n", sd2&sd3           ? "true" : "false");
		printf("sd2 & sd5        == false: %s\n", sd2&sd5           ? "true" : "false");
		printf("sd2 & a          == false: %s\n", sd2&a             ? "true" : "false");
		printf("sd2 & b          == true : %s\n", sd2&b             ? "true" : "false");
		printf("sd2 < sd3        == true : %s\n", sd2<sd3           ? "true" : "false");
		printf("sd2 < sd4        == false: %s\n", sd2<sd4           ? "true" : "false");
		printf("sd3 <= sd2       == false: %s\n", sd3<=sd2          ? "true" : "false");
		printf("sd2 >= sd2       == true : %s\n", sd2>=sd2          ? "true" : "false");
		printf("sd3 >= sd2       == true : %s\n", sd3>=sd2          ? "true" : "false");
		printf("sd2 <= sd2       == true : %s\n", sd2<=sd2          ? "true" : "false");
		printf("sd2 >= sd5       == false: %s\n", sd2>=sd5          ? "true" : "false");
		printf("sd3 >= sd2       == true : %s\n", sd3>=sd2          ? "true" : "false");
		printf("sd3 <= sd5       == false: %s\n", sd3<=sd5          ? "true" : "false");
		printf("sd5 >= sd3       == false: %s\n", sd5>=sd3          ? "true" : "false");
		printf("sd2 >= a         == false: %s\n", sd2>=a            ? "true" : "false");
		printf("sd2 >= b         == true : %s\n", sd2>=b            ? "true" : "false");
		printf("sd2 >= c         == false: %s\n", sd2>=c            ? "true" : "false");
		printf("sd1.contains(a)  == true : %s\n", sd1.contains(a)   ? "true" : "false");
		printf("sd1.contains(b)  == false: %s\n", sd1.contains(b)   ? "true" : "false");
		printf("sd1.contains(c)  == false: %s\n", sd1.contains(c)   ? "true" : "false");
		printf("sd3.contains(a)  == true : %s\n", sd3.contains(a)   ? "true" : "false");
		printf("sd3.contains(b)  == true : %s\n", sd3.contains(b)   ? "true" : "false");
		printf("sd3.contains(c)  == false: %s\n", sd3.contains(c)   ? "true" : "false");
		printf("sd4.contains(a)  == false: %s\n", sd4.contains(a)   ? "true" : "false");
		printf("sd4.contains(b)  == false: %s\n", sd4.contains(b)   ? "true" : "false");
		printf("sd4.contains(c)  == true : %s\n", sd4.contains(c)   ? "true" : "false");
		printf("sd6.contains(a)  == false: %s\n", sd6.contains(a)   ? "true" : "false");
		printf("sd6.contains(b)  == true : %s\n", sd6.contains(b)   ? "true" : "false");
		printf("sd6.contains(c)  == true : %s\n", sd6.contains(c)   ? "true" : "false");
		printf("sd3 != sd        == true : %s\n", sd3 != sd         ? "true" : "false");
		printf("sd3.contains(sd1)== true : %s\n", sd3.contains(sd1) ? "true" : "false");
		printf("sd6.contains(sd2)== true : %s\n", sd6.contains(sd2) ? "true" : "false");
		printf("sd1.contains(sd3)== false: %s\n", sd1.contains(sd3) ? "true" : "false");
		printf("sd3.contains(sd3)== true : %s\n", sd3.contains(sd3) ? "true" : "false");

	}
	catch (enumset_exception &e) {
		printf("1) %s", typeid(e).name());
	}
	
	return 0;
}
