#include <stdio.h>
#include "enumset.hpp"

using namespace mbo;

enum TEnum {a=01, b=04, c=010};
  
typedef enumset<TEnum> TSet;

char * result(const TSet & es) {
	if (!es.count())       return "[]";
	if (es==TSet(1,a))     return "[a]";
	if (es==TSet(1,b))     return "[b]";
	if (es==TSet(1,c))     return "[c]";
	if (es==TSet(2,a,b))   return "[ab]";
	if (es==TSet(2,a,c))   return "[ac]";
	if (es==TSet(2,b,c))   return "[bc]";
	if (es==TSet(3,a,b,c)) return "[abc]";
	return "illegal: more than a+b+c";
}

#define Execute(st) \
  st;\
  printf( "%-17s=> %s\n", # st, result(es))

int main(int argc, void ** argv)
{
	try {
		TSet es;                   // []
	 
		Execute( ;                ); // []
		Execute( es += a          ); // [a]    addition, union
		Execute( es  = es + b     ); // [a,b]  ditto
		Execute( es += es         ); // [a,b]  ditto
		Execute( es *= b          ); // [b]    intersection
		Execute( es  = es + c     ); // [b,c]  addition
		Execute( es -= b          ); // [c]    minus
		Execute( es.clear()       ); // []     clear
		Execute( es = TSet(0)     ); // []     dynamic creation
		Execute( es = TSet(2,a,c) ); // [a,c]  dynamic creation
		Execute( es = TEnum(es)   ); // exception catched in first handler
	}
	catch (demap_value_exception &e) {
		printf("illegal TSet value, count != 1\n");
	}
	catch (enumset_exception &e) {
		printf("enumset exception\n");
	}
	printf("test finished\n");
	return 0;
}
